-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

--[[local M = {}

local running = false

local speederCrashTimeout = 0 --s
local speeder2CrashTimeout = 5 --s

local vehicle = nil
local speeder = nil
local speeder2 = nil

local maxPoliceDamage = 15500 --no unit

local speederMinimumSpeed = 0.1 --m/s

local arrestingSpeeder = false
local arrestingSpeeder2 = false

local speederArrested = false
local speeder2Arrested = false

local arrestCount = 0

local function reset()

    speederCrashTimeout = 5
    speeder2CrashTimeout = 5


    arrestingSpeeder = false
    arrestingSpeeder2 = false

    speederArrested = false
    speeder2Arrested = false

    arrestCount = 0

    running = false
end

local function onRaceStart()
    reset()
    running = true
    
    vehicle = scenetree.findObject('scenario_player0')
    speeder = scenetree.findObject('speeder')
    speeder2 = scenetree.findObject('speeder2')
    
    vehicle:queueLuaCommand('mapmgr.enableTracking("policeCar")')

    speeder:queueLuaCommand('ai.setState({mode="flee"})')    
    speeder:queueLuaCommand('mapmgr.enableTracking("speeder")')

    speeder2:queueLuaCommand('ai.setState({mode="flee"})')
    speeder2:queueLuaCommand('mapmgr.enableTracking("speeder2")')
end

local function onRaceWaypoint(data) 
    if data.waypointName == 'pp_wp_1' then
        guihooks.trigger('ScenarioFlashMessage', {{'Stop the boy racers!', 10}} )
    end
end

local function disableSpeeder1()
    speederArrested = true
    speeder = scenetree.findObject('speeder')
    speeder:queueLuaCommand('ai.setState({mode="stopping"})')
    speeder:queueLuaCommand('mapmgr.enableTracking("speeder")')
    arrestCount = arrestCount + 1
    if arrestCount == 1 then
        guihooks.trigger('ScenarioFlashMessage', {{'1st Speeeder Arrested!', 0.5}} )
    elseif arrestCount == 2 then
        guihooks.trigger('ScenarioFlashMessage', {{'2nd Speeeder Arrested!', 0.5}} )
    end
end

local function disableSpeeder2()
    speeder2Arrested = true
    speeder2 = scenetree.findObject('speeder2')
    speeder2:queueLuaCommand('ai.setState({mode="stopping"})')
    speeder:queueLuaCommand('mapmgr.enableTracking("speeder2")')
    arrestCount = arrestCount + 1
    if arrestCount == 1 then
        guihooks.trigger('ScenarioFlashMessage', {{'1st Speeeder Arrested!', 0.5}} )
    elseif arrestCount == 2 then
        guihooks.trigger('ScenarioFlashMessage', {{'2nd Speeeder Arrested!', 0.5}} )
    end
end

local function fail(reason)
    scenarios.finish({failed = reason})
    reset()
end

local function success(reason)     
    scenarios.finish({msg = reason})
    reset()
end

local function onRaceTick(raceTickTime)  
    if not running then
        return
    end
    
    local policeData = map.objects.policeCar
    local speederData = map.objects.speeder
    local speeder2Data = map.objects.speeder2
    
    if not policeData or not speederData  or not speeder2Data then
        return
    end
    
    local speederSpeed = speederData.vel:length()
    local speeder2Speed = speeder2Data.vel:length()
    
    if policeData.damage > maxPoliceDamage then
        fail('You crashed your car')
    end

    if speederSpeed < speederMinimumSpeed and speederArrested == false then 
        if arrestingSpeeder2 == false then
            arrestingSpeeder = true
            speederCrashTimeout = speederCrashTimeout - raceTickTime
            if speederCrashTimeout % 1 == 0 then
                if speederCrashTimeout > 0 then
                    guihooks.trigger('ScenarioFlashMessage', {{speederCrashTimeout..'...', 0.5}} )
                elseif speederCrashTimeout == 0 then
                    arrestingSpeeder = false
                    disableSpeeder1()
                end
            end
        end
    else
        speederCrashTimeout = 5
        arrestingSpeeder = false
    end

    if speeder2Speed < speederMinimumSpeed and speeder2Arrested == false then
        if arrestingSpeeder == false then
            arrestingSpeeder2 = true
            speeder2CrashTimeout = speeder2CrashTimeout - raceTickTime
            if speeder2CrashTimeout % 1 == 0 then
                if speeder2CrashTimeout > 0 then
                    guihooks.trigger('ScenarioFlashMessage', {{speeder2CrashTimeout..'...', 0.5}} )
                elseif speeder2CrashTimeout == 0 then
                    arrestingSpeeder2 = false
                    disableSpeeder2()
                end
            end
        end
    else
        speeder2CrashTimeout = 5
        arrestingSpeeder2 = false
    end
    
    if speederArrested == true and speeder2Arrested == true then
        success("You did it :)")
    end

end

M.onRaceStart = onRaceStart
M.onRaceWaypoint = onRaceWaypoint
M.onRaceTick = onRaceTick

return M --]]